#include <iostream>

using namespace std;

#define int long long
#define float double
#define double long double

void solve() {
	int n, m, x, a, b;
	cin >> n >> m >> x >> a >> b;
	if (a % x == 0 && b % x == 0) {
		cout << "Right here" << endl;
		return;
	}
	int west = a % x, east = 1e18, north = b % x, south = 1e18;
	if ((a + x - 1) / x * x <= n) {
		east = x - a % x;
	}
	if ((b + x - 1) / x * x <= m) {
		south = x - b % x;
	}
	if (west > 0 && east > 0) {
		if (west <= east) {
			cout << "West " << west << endl;
		} else {
			cout << "East " << east << endl;
		}
	}
	if (north > 0 && south > 0) {
		if (north <= south) {
			cout << "North " << north << endl;
		} else {
			cout << "South " << south << endl;
		}
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.setf(ios::fixed, ios::floatfield);
	cout.precision(8);
	cerr.tie(0);
	cerr.setf(ios::fixed, ios::floatfield);
	cerr.precision(4);
	solve();
}
